import sys
sys.path.append("/usr/share/rhn")
from up2date_client import rhnreg
from up2date_client import rhnregGui, rhnserver
from up2date_client import messageWindow
import gtk
from gtk import glade
import gettext
_ = lambda x: gettext.ldgettext("rhn-client-tools", x)
gtk.glade.bindtextdomain("rhn-client-tools")
from firstboot.module import Module
from firstboot.constants import *

class moduleClass(Module):
    def __init__(self):
        Module.__init__(self)
        self.priority = 108.8
        self.sidebarTitle = _("Ksplice Registration")
        self.title = _("Configure Rebootless Updates")

    def needsNetwork(self):
        return True

    def apply(self, interface, testing=False):
        if testing:
            return RESULT_SUCCESS

        ret = self.kspliceSetupPage.kspliceSetupPageApply()
        if self.kspliceSetupPage.go_to_finish:
            interface.moveToPage(moduleTitle=_("Finish Updates Setup"))
            return RESULT_JUMP
        if ret:
            return RESULT_FAILURE

    def createScreen(self):
        self.kspliceSetupPage = FirstbootKsplicePage()
        self.vbox = gtk.VBox(spacing=5)
        self.vbox.pack_start(self.kspliceSetupPage.kspliceSetupPageVbox(), True, True)

    def initializeUI(self):
        self.kspliceSetupPage.kspliceSetupPagePrepare()

    def shouldAppear(self):
        if rhnreg.registered():
            return False
        return True

class FirstbootKsplicePage(rhnregGui.KspliceSetupPage):
    def __init__(self):
        rhnregGui.KspliceSetupPage.__init__(self)

    def kspliceSetupPageApply(self):
        self.go_to_finish = False
        return rhnregGui.KspliceSetupPage.kspliceSetupPageApply(self)

    def fatalError(self, error, wrap=1):
        msg = _("There was a communication error with the server:") \
            + "\n\n" + error + "\n\n" \
	    + _("Would you like to go back and try again?")
        dlg = messageWindow.YesNoDialog(msg)
        ret = dlg.getrc()
        if not ret:
            self.go_to_finish = True

    def goToPageAfterLogin(self):
        pass
